#!/usr/bin/env python
# coding: utf-8

# # Helper function for visualising thedendrograms and the time series

# In[ ]:


dataframes.dataframes_norm[0].values.shape
timeSeries = dataframes.dataframes_norm[0].T
print(timeSeries.shape)
print(type(timeSeries.values))
print(timeSeries.values.shape)



import timeit
from dtaidistance import clustering
from dtaidistance import dtw
# Custom Hierarchical clustering
model1 = clustering.Hierarchical(dtw.distance_matrix,  {})
# Augment Hierarchical object to keep track of the full tree
model2 = clustering.HierarchicalTree(model1)
# SciPy linkage clustering
model3 = clustering.LinkageTree(dtw.distance_matrix, dists_options={"use_c":True, "window":window_size_dtw})
# use_c =True, window=100
start = timeit.default_timer()
method = 'average'
cluster_idx = model3.fit(timeSeries.values, method = method)
end = timeit.default_timer()

print("Time: ",end-start)
print(model3)

fig, ax = plt.subplots(nrows=1, ncols=2, figsize=(20, 15))
show_ts_label = lambda idx: dataframes.dataframes_norm[0].columns[idx]
model3.plot(path_pictures_dtw+"dendrogram_dtaidistance_2"+method+".png", axes=ax, show_ts_label=show_ts_label,
           show_tr_label=True, ts_label_margin=-200, ts_height = 100,
           ts_left_margin=-50, ts_sample_length=1, tr_label_margin=1, tr_left_margin=0)
plt.show()

